#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

int main(void) {
    int n;
    scanf("%d", &n);
    vector<int> par(n);
    vector<ll> flow(n);
    for (int i = 1; i < n; ++i) scanf("%d", &par[i]), --par[i];
    for (auto &f: flow) scanf("%lld", &f);

    vector<vector<int>> children(n);
    for (int i = 1; i < n; ++i) 
        children[par[i]].push_back(i);

    vector<ll> minflow(n, 1);
    function<ll(int)> find_min = [&](int u) -> ll {
        ll c_sum = 0;
        for (int v: children[u])
            c_sum += find_min(v);
        return minflow[u] = max(1LL, max(flow[u], c_sum));
    };
    find_min(0);

    vector<ll> c_minrem(n), c_unknown(n), c_sum(n);
    for (int u = 0; u < n; ++u)
        for (int v: children[u]) {
            if (flow[v] <= 0) {
                c_minrem[u] += minflow[v];
                ++c_unknown[u];
            } else
                c_sum[u] += flow[v];
        }
    
    vector<int> Q;
    bool impossible = false;
    auto assign = [&](int u, ll f) {
        if (f <= 0) impossible = true;
        flow[u] = f;
        if (u) {
            --c_unknown[par[u]];
            c_minrem[par[u]] -= minflow[u];
            c_sum[par[u]] += flow[u];
        }
        Q.push_back(u);
    };

    auto check = [&](int u) {
        if (flow[u] > 0) return;
        if (flow[u] <= 0 && c_unknown[u] == 0 && !children[u].empty()) {
            assign(u, c_sum[u]);
            return;
        }
        if (u == 0) return;
        int v = par[u];
        if (flow[v] > 0 && c_unknown[v] == 1) {
            assign(u, flow[v] - c_sum[v]);
            return;
        }
        if (flow[v] - c_sum[v] == c_minrem[v]) {
            assign(u, minflow[u]);
            return;
        }
    };
    for (int u = 0; u < n && !impossible; ++u) check(u);
    while (!impossible && !Q.empty()) {
        int u = Q.back(); Q.pop_back();
        if (u > 0) {
            check(par[u]);
            // oops, checking all siblings is going to be costly
            for (int v: children[par[u]]) check(v);
        }
        for (int v: children[u]) check(v);
    }

    for (int u = 0; !impossible && u < n; ++u)
        impossible |= c_unknown[u] || flow[u] <= 0 || !children[u].empty() && c_sum[u] != flow[u];
    
    if (impossible)
        printf("impossible\n");
    else
        for (int u = 0; u < n; ++u)
            printf("%lld\n", flow[u]);
}
